const passport = require('passport');
const LocalStrategy = require('passport-local').Strategy;
const GoogleStrategy = require('passport-google-oauth20').Strategy;
const User = require('./models/User');

// Local Strategy
passport.use(new LocalStrategy(
    { usernameField: 'username' },
    async function(username, password, done) {
        try {
            const user = await User.authenticate(username, password);
            if (!user) {
                return done(null, false, { message: 'Identifiants incorrects.' });
            }
            return done(null, user);
        } catch (err) {
            return done(err);
        }
    }
));

// Google OAuth2 Strategy
passport.use(new GoogleStrategy({
    clientID: '1011352082256-ejjddbrggliv0ooas4nquu319p06573p.apps.googleusercontent.com',
    clientSecret: '-qoNCHAeG2i47cuFrSCQWFgZ',
    callbackURL: 'http://localhost:8080/auth/google/callback',
    passReqToCallback   : true
}, async function(accessToken, refreshToken, profile, done) {
    // Find or create the user based on the Google profile
    try {
        const user = await User.findOne({ googleId: profile.id });
        if (user) {
            return done(null, user);
        } else {
            const newUser = new User({
                username: profile.emails[0].value,
            });
            const savedUser = await newUser.save();
            return done(null, savedUser);
        }
    } catch (err) {
        return done(err);
    }
}));

passport.serializeUser(function(user, done) {
    done(null, user.username);
});

passport.deserializeUser(async function(username, done) {
    try {
        const user = await User.findOne({ username: username });
        if (!user) {
            return done(null, false, { message: 'Utilisateur non trouvé.' });
        }
        return done(null, user);
    } catch (error) {
        return done(error);
    }
});

module.exports = passport;
